GLOBAL.require 'screens.vemscreen'
GLOBAL.require 'screens.tbscreen'
GetPlayer = GLOBAL.GetPlayer
IsHUDPaused = GLOBAL.IsPaused
TheInput = GLOBAL.TheInput
TheFrontEnd = GLOBAL.TheFrontEnd
TheSim = GLOBAL.TheSim
local STRINGS = GLOBAL.STRINGS
local Recipe = GLOBAL.Recipe
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local TECH = GLOBAL.TECH

PrefabFiles = {
"vending_machine",
"coins",
"demon_ticket",
"altar_broken_portable",
"altar_portable",
"task_board",
}

Assets=
{
Asset("ANIM", "anim/vending_machine.zip"),
Asset("ATLAS", "images/inventoryimages/vending_machine.xml"),
Asset("IMAGE", "images/inventoryimages/vending_machine.tex"),
Asset("IMAGE", "minimap/vending_machine.tex" ),
Asset("ATLAS", "minimap/vending_machine.xml" ),

Asset("ANIM", "anim/task_board.zip"),
Asset("ATLAS", "images/inventoryimages/task_board.xml"),
Asset("IMAGE", "images/inventoryimages/task_board.tex"),
Asset("IMAGE", "minimap/task_board.tex" ),
Asset("ATLAS", "minimap/task_board.xml" ),

Asset("ATLAS", "images/globalpanels_task.xml"),
Asset("IMAGE", "images/globalpanels_task.tex"),

Asset("ANIM", "anim/coins.zip"),
Asset("ATLAS", "images/inventoryimages/coins.xml"),
Asset("IMAGE", "images/inventoryimages/coins.tex"),

Asset("ANIM", "anim/demon_ticket.zip"),
Asset("ATLAS", "images/inventoryimages/demon_ticket.xml"),
Asset("IMAGE", "images/inventoryimages/demon_ticket.tex"),

Asset("ATLAS", "images/inventoryimages/altar_broken_portable.xml"),
Asset("IMAGE", "images/inventoryimages/altar_broken_portable.tex"),
Asset("IMAGE", "minimap/altar_broken_portable.tex" ),
Asset("ATLAS", "minimap/altar_broken_portable.xml" ),

Asset("ATLAS", "images/inventoryimages/altar_portable.xml"),
Asset("IMAGE", "images/inventoryimages/altar_portable.tex"),
Asset("IMAGE", "minimap/altar_portable.tex" ),
Asset("ATLAS", "minimap/altar_portable.xml" ),
}
AddMinimapAtlas("minimap/vending_machine.xml")
AddMinimapAtlas("minimap/altar_broken_portable.xml")
AddMinimapAtlas("minimap/altar_portable.xml")
AddMinimapAtlas("minimap/task_board.xml")

STRINGS.NAMES.VENDING_MACHINE = "Vending machine"
STRINGS.RECIPE_DESC.VENDING_MACHINE = "Let's shop."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.VENDING_MACHINE = {"Where do the goods come from?"}

STRINGS.NAMES.TASK_BOARD = "Task board"
STRINGS.RECIPE_DESC.TASK_BOARD = "A good way to earn money."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TASK_BOARD = {"A strange board with a strange chest."}

STRINGS.NAMES.COINS = "Coins"
STRINGS.RECIPE_DESC.COINS = "Just for trading system."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.COINS = {"Why not to use banknotes?"}

STRINGS.NAMES.DEMON_TICKET = "Demon ticket"
STRINGS.RECIPE_DESC.DEMON_TICKET = "Just for trading system."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.DEMON_TICKET = {"This portraits looks familiar."}

STRINGS.NAMES.ALTAR_BROKEN_PORTABLE = "Broken altar(portable)"
STRINGS.RECIPE_DESC.ALTAR_BROKEN_PORTABLE = "Kidding me?"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ALTAR_BROKEN_PORTABLE = {"How cute."}

STRINGS.NAMES.ALTAR_PORTABLE = "Altar(portable)"
STRINGS.RECIPE_DESC.ALTAR_PORTABLE = "Seriously?"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ALTAR_PORTABLE = {"Tiny,but powerful."}

local vending_machine = Recipe("vending_machine", { Ingredient("boards", 2), Ingredient("cutstone", 2), Ingredient("gears", 2) }, RECIPETABS.TOWN, TECH.SCIENCE_ONE, "vending_machine_placer", 10)
vending_machine.atlas = "images/inventoryimages/vending_machine.xml"

local task_board = Recipe("task_board", { Ingredient("boards", 4), Ingredient("papyrus", 2) }, RECIPETABS.TOWN, TECH.SCIENCE_ONE, "task_board_placer", 10)
task_board.atlas = "images/inventoryimages/task_board.xml"

local demon_ticket_icon = Ingredient( "demon_ticket", 4)
demon_ticket_icon.atlas = "images/inventoryimages/demon_ticket.xml"

local altar_broken_portable = Recipe("altar_broken_portable", {Ingredient("thulecite", 4), demon_ticket_icon, Ingredient("minotaurhorn", 1) }, RECIPETABS.ANCIENT, TECH.ANCIENT_TWO,nil,nil,true)
altar_broken_portable.atlas = "images/inventoryimages/altar_broken_portable.xml"

local altar_b_p = Ingredient( "altar_broken_portable", 1)
altar_b_p.atlas = "images/inventoryimages/altar_broken_portable.xml"

local altar_portable = Recipe("altar_portable", {Ingredient("thulecite", 6), demon_ticket_icon, altar_b_p }, RECIPETABS.ANCIENT, TECH.ANCIENT_FOUR,nil,nil,true)
altar_portable.atlas = "images/inventoryimages/altar_portable.xml"

local function BossDropDTPostInit( inst )
    inst.components.lootdropper:AddChanceLoot("demon_ticket", 1.0)
end

AddPrefabPostInit("bearger", BossDropDTPostInit)
AddPrefabPostInit("moose", BossDropDTPostInit)
AddPrefabPostInit("dragonfly", BossDropDTPostInit)
AddPrefabPostInit("deerclops", BossDropDTPostInit)

GLOBAL.TheInput:AddKeyUpHandler(GLOBAL.KEY_Y, function()--Y键刷新(测试用)
    GLOBAL.VEM_random = true
	GLOBAL.TB_random = true
	GLOBAL.GetPlayer():RemoveTag("completetask")
	GLOBAL.GetPlayer():RemoveTag("accepttask")
	GLOBAL.GetPlayer():RemoveTag("acceptbigtask")
end)

--[[
TMIKeyHandler = Class(function(self)   
    self.handler = TheInput:AddKeyHandler(function(key, down) self:OnRawKey(key, down) end )
end)

function TMIKeyHandler:OnRawKey(key, down)
	if IsHUDPaused() or not GetPlayer() then return end
	
	if (key == GLOBAL.KEY_T and not down) then
		GLOBAL.TheFrontEnd:PushScreen(GLOBAL.TMIScreen())
	end
end

CJBTMIKeyHandler = TMIKeyHandler()
--]]