local assets=
{
	Asset("ANIM", "anim/coins.zip"),
	Asset("ATLAS", "images/inventoryimages/coins.xml"),
}

local function shine(inst)
    inst.task = nil
    inst.AnimState:PlayAnimation("spark")
    inst.AnimState:PushAnimation("idle")
    inst.task = inst:DoTaskInTime(4+math.random()*5, function() shine(inst) end)
end

local function fn(Sim)
    
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddPhysics()
    MakeInventoryPhysics(inst)
	
    inst.AnimState:SetBank("coins")
    inst.AnimState:SetBuild("coins")
    inst.AnimState:PlayAnimation("idle")
	--trans:SetScale(.5,.5,.5)

    inst:AddComponent("edible")
    inst.components.edible.foodtype = "ELEMENTAL"
    inst.components.edible.hungervalue = 2
    inst:AddComponent("tradable")
    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = 999
	
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/coins.xml"

    --inst:AddComponent("bait")
    --inst:AddTag("molebait")
    shine(inst)
    return inst
end

return Prefab( "common/inventory/coins", fn, assets) 