local assets=
{
	Asset("ANIM", "anim/demon_ticket.zip"),
	Asset("ATLAS", "images/inventoryimages/demon_ticket.xml"),
}

local function fn(Sim)
    
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize( 1, .3 )
	inst.entity:AddPhysics()
    MakeInventoryPhysics(inst)
	
    inst.AnimState:SetBank("demon_ticket")
    inst.AnimState:SetBuild("demon_ticket")
    inst.AnimState:PlayAnimation("idle")
	--trans:SetScale(.5,.5,.5)

    inst:AddComponent("edible")
    inst.components.edible.foodtype = "ELEMENTAL"
    inst.components.edible.hungervalue = 2
    inst:AddComponent("tradable")
    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = 999
	
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/demon_ticket.xml"
	inst:DoPeriodicTask(2, function()
		inst.AnimState:PlayAnimation("idle")
	end)
	
	return inst
end

return Prefab( "common/inventory/demon_ticket", fn, assets) 