require "prefabutil"

local assets =
{
Asset("ANIM", "anim/task_board.zip"),
Asset("IMAGE", "images/inventoryimages/task_board.tex"),
Asset("ATLAS", "images/inventoryimages/task_board.xml"),
}

local prefabs = 
{
"task_board",
}

local slotpos_3x3 = {}  --3x3箱子

for y = 2, 0, -1 do
    for x = 0, 2 do
        table.insert(slotpos_3x3, Vector3(80*x-80*2+80, 80*y-80*2+80,0))
    end
end

local function onopen(inst)	
end 

local function onclose(inst) 	
end 

local function itemtest(inst, item, slot)
	return true
end

local function getstatus(inst)
end
--[[
local function onhammered(inst, worker)
    inst.components.lootdropper:DropLoot()
	inst.components.container:DropEverything()
    SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
    inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")
    inst:Remove()
end
--]]
local function onhit(inst, worker)
inst.AnimState:PlayAnimation("hit")
inst.AnimState:PushAnimation("idle", true)
end

local function onbuilt(inst)
inst.AnimState:PlayAnimation("place")
inst.AnimState:PushAnimation("idle")
end

local function onburnt(inst)
inst.components.container:DropEverything()
SpawnPrefab("ash").Transform:SetPosition(inst.Transform:GetWorldPosition())
SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")
inst:Remove()
end

TB_random = false

local function task(inst, target, number, reward)
	GetPlayer().components.talker:Say("Let the hunt begin.", 5, false)
	GetPlayer().SoundEmitter:PlaySound("dontstarve/HUD/research_available")
	GetPlayer():AddTag("accepttask")
	local name = target
	local pt = inst:GetPosition()
	if number == 1 then
		local wanted = SpawnPrefab(name)
		wanted.Transform:SetPosition(pt.x+(math.random(10)-math.random(10)), 0, pt.z+(math.random(10)-math.random(10)))
		wanted.components.health:SetMaxHealth(2800)
		wanted.components.health:DoDelta(2800)
		--wanted.components.lootdropper:SetLoot(nil)
		--wanted.components.lootdropper:SetChanceLootTable(nil)
		wanted.Transform:SetScale(1.5, 1.5, 1.5)
		local minimap = wanted.entity:AddMiniMapEntity()
		minimap:SetIcon( "lucy_axe.png" )
		wanted:ListenForEvent("death", function()
			local hasemptyslot = true
			if GetPlayer().components.inventory:IsFull() then
				local equipslot = GetPlayer().components.inventory.equipslots
				local backpack_found = 0
				for k,v in pairs(equipslot) do
					if v and v.prefab == "backpack" or v.prefab == "piggyback"	or v.prefab == "krampus_sack" then
						if not v.components.container:IsFull() then
							backpack_found = backpack_found + 1
						end
					end
				end
				if backpack_found == 0 then
					hasemptyslot = false
				end
			end
			if hasemptyslot then
				for k = 1, reward do
					local coins = SpawnPrefab("coins")
					GetPlayer().components.inventory:GiveItem(coins)
					GetPlayer().SoundEmitter:PlaySound("dontstarve/HUD/get_gold")
				end
			else
				for k = 1, reward do
					SpawnPrefab("coins").Transform:SetPosition(GetPlayer().Transform:GetWorldPosition())
					GetPlayer().SoundEmitter:PlaySound("dontstarve/HUD/get_gold")
				end
			end
		end)
	else
		local wanted = {}
		local hp = 2800 / number
		for k = 1, number do
			wanted[k] = SpawnPrefab(name)
			wanted[k].Transform:SetPosition(pt.x+(math.random(15)-math.random(15)), 0, pt.z+(math.random(15)-math.random(15)))
			wanted[k].components.health:SetMaxHealth(hp + (100 * math.random(3)))
			wanted[k].components.health:DoDelta((hp + 300))
			--wanted[k].components.lootdropper:SetLoot(nil)
			--wanted[k].components.lootdropper:SetChanceLootTable(nil)
			wanted[k].Transform:SetScale(1.5, 1.5, 1.5)
			local minimap = wanted[k].entity:AddMiniMapEntity()
			minimap:SetIcon( "lucy_axe.png" )
		end
		local monster_left = number
		for k = 1, number do
			wanted[k]:ListenForEvent("death", function()
				monster_left = monster_left - 1
				if monster_left == 0 then
					local hasemptyslot = true
					if GetPlayer().components.inventory:IsFull() then
						local equipslot = GetPlayer().components.inventory.equipslots
						local backpack_found = 0
						for k,v in pairs(equipslot) do
							if v and v.prefab == "backpack" or v.prefab == "piggyback"	or v.prefab == "krampus_sack" then
								if not v.components.container:IsFull() then
									backpack_found = backpack_found + 1
								end
							end
						end
						if backpack_found == 0 then
							hasemptyslot = false
						end
					end
					if hasemptyslot then
						for k = 1, reward do
							local coins = SpawnPrefab("coins")
							GetPlayer().components.inventory:GiveItem(coins)
							GetPlayer().SoundEmitter:PlaySound("dontstarve/HUD/get_gold")
						end
					else
						for k = 1, reward do
							SpawnPrefab("coins").Transform:SetPosition(GetPlayer().Transform:GetWorldPosition())
							GetPlayer().SoundEmitter:PlaySound("dontstarve/HUD/get_gold")
						end
					end
				end
			end)
		end
	end
end

local function task_giant(inst, target)
	GetPlayer():AddTag("acceptbigtask")
	local wanted = SpawnPrefab(target)
	local minimap = wanted.entity:AddMiniMapEntity()
	minimap:SetIcon( "lucy_axe.png" )
	if wanted ~= nil then
		GetPlayer().components.talker:Say("Let the hunt begin.", 5, false)
		GetPlayer().SoundEmitter:PlaySound("dontstarve/HUD/research_available")
		local theta = math.random() * 2 * PI
		local pt = inst:GetPosition()
		local radius = 20
		local offset = FindWalkableOffset(pt, theta, radius, 12, true)
		if offset then
			local pos = pt + offset
			wanted.Transform:SetPosition(pos:Get())
		else
			wanted.Transform:SetPosition(pt.x+(math.random(10)-math.random(10)), 0, pt.z+(math.random(10)-math.random(10)))
		end
	end
end
local function fn(Sim)
local inst = CreateEntity()
local trans = inst.entity:AddTransform()
local anim = inst.entity:AddAnimState()
inst.entity:AddSoundEmitter()

MakeObstaclePhysics(inst, 1.5)

anim:SetBank("task_board")
anim:SetBuild("task_board")
--anim:SetMultColour(255/255,105/255,0/255,1)
anim:PlayAnimation("idle")
--trans:SetScale(1, 1, 1)

local minimap = inst.entity:AddMiniMapEntity()
--minimap:SetPriority( 5 )
minimap:SetIcon( "task_board.png" )

inst:AddTag("structure")
inst:AddComponent("lootdropper")
--[[
inst:AddComponent("workable")
inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
inst.components.workable:SetWorkLeft(4)
inst.components.workable:SetOnFinishCallback(onhammered)
inst.components.workable:SetOnWorkCallback(onhit)
--]]
inst:AddComponent("inspectable")
--[[
inst.components.inspectable.getstatus = function()
    local range = 3
    local pos = Vector3(GetPlayer().Transform:GetWorldPosition())
    local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, range)
	for k,v in pairs(ents) do
	if v.prefab == "task_board" then
       TheFrontEnd:PushScreen(VEMScreen())
	end
	end
end
--]]
inst:AddComponent("container")
inst.components.container.itemtestfn = itemtest
inst.components.container:SetNumSlots(#slotpos_3x3)
    
inst.components.container.onopenfn = onopen
inst.components.container.onclosefn = onclose

inst.components.container.widgetslotpos = slotpos_3x3
inst.components.container.widgetanimbank = "ui_chest_3x3"
inst.components.container.widgetanimbuild = "ui_chest_3x3"
inst.components.container.widgetpos = Vector3(160,80,0)
inst.components.container.side_align_tip = 160
MakeLargeBurnable(inst)
inst.components.burnable.onburnt = onburnt

local widgetbuttoninfo = {
	text = "Check",
	position = Vector3(-80, -140, 0),
	fn = function(inst)
		--GetPlayer().components.talker:Say("No task.", 5, false)
		GetPlayer().components.locomotor:Clear()
		TheFrontEnd:PushScreen(TBScreen())
		if inst.components.container:Has(todaystask[1], todaystask[2]) and (not GetPlayer():HasTag("completetask")) then
			inst.components.container:ConsumeByName(todaystask[1], todaystask[2])
			if inst.components.container:IsFull() then
				for k = 1, todaystask[3] do
					local coins = SpawnPrefab("coins")
					GetPlayer().components.inventory:GiveItem(coins)
				end
			else
				for k = 1, todaystask[3] do
					local coins = SpawnPrefab("coins")
					inst.components.container:GiveItem(coins)
				end
			end
			GetPlayer().components.talker:Say("Delivery complete.", 5, false)
			GetPlayer():AddTag("completetask")
		end
end }
local widgetbuttoninfo2 = {
	text = "Hunt",
	position = Vector3(80, -140, 0),
	fn = function(inst)
		if inst.components.container:Has("meat", 5) then
			if TB_random or #todaysprey < 3 then
				GetPlayer().components.talker:Say("Let's check it firstly.", 5, false)
			else
				local target = todaysprey[1]
				local number = todaysprey[2]
				local reward = todaysprey[3]
				if GetPlayer():HasTag("accepttask") then
					GetPlayer().components.talker:Say("Already accept one today.", 5, false)
				else
					inst.components.container:ConsumeByName("meat", 5)
					task(inst, target, number, reward)
				end
			end
		elseif inst.components.container:Has("greengem", 5) then
			if GetPlayer():HasTag("acceptbigtask") then
				GetPlayer().components.talker:Say("Already accept one in this season.", 5, false)
			else
				task_giant(inst, "moose")
				inst.components.container:ConsumeByName("greengem", 5)
			end
		elseif inst.components.container:Has("orangegem", 5) then
			if GetPlayer():HasTag("acceptbigtask") then
				GetPlayer().components.talker:Say("Already accept one in this season.", 5, false)
			else
				task_giant(inst, "dragonfly")
				inst.components.container:ConsumeByName("orangegem", 5)
			end
		elseif inst.components.container:Has("yellowgem", 5) then
			if GetPlayer():HasTag("acceptbigtask") then
				GetPlayer().components.talker:Say("Already accept one in this season.", 5, false)
			else
				task_giant(inst, "bearger")
				inst.components.container:ConsumeByName("yellowgem", 5)
			end
		elseif inst.components.container:Has("purplegem", 5) then
			if GetPlayer():HasTag("acceptbigtask") then
				GetPlayer().components.talker:Say("Already accept one in this season.", 5, false)
			else
				task_giant(inst, "deerclops")
				inst.components.container:ConsumeByName("purplegem", 5)
			end
		else
			GetPlayer().components.talker:Say("I should put cost into it.", 5, false)
		end
end }

inst.components.container.widgetbuttoninfo = widgetbuttoninfo
inst.components.container.widgetbuttoninfo2 = widgetbuttoninfo2

inst:ListenForEvent( "daytime", function()
	if GetPlayer():HasTag("accepttask") then
		GetPlayer():RemoveTag("accepttask")
	end
	TB_random = true
	if GetPlayer():HasTag("completetask") then
		GetPlayer():RemoveTag("completetask")
	end
end, GetWorld())
inst:ListenForEvent( "seasonChange", function()
	if GetPlayer():HasTag("acceptbigtask") then
		GetPlayer():RemoveTag("acceptbigtask")
	end
end, GetWorld())

local function onsave(inst, data)
	if todaystask and #todaystask > 0 then
		data.todaystask = {}
		data.todaystask = todaystask
	end
	if todaysprey and #todaysprey > 0 then
		data.todaysprey = {}
		data.todaysprey = todaysprey
	end
	if GetPlayer():HasTag("completetask") then
		data.completetask = true
	end
	if GetPlayer():HasTag("accepttask") then
		data.accepttask = true
	end
	if GetPlayer():HasTag("acceptbigtask") then
		data.acceptbigtask = true
	end
	if TB_random then
		data.TB_random = true
	end
end
local function onload(inst, data)
	if data and data.todaystask then
		todaystask = data.todaystask
	end
	if data and data.todaysprey then
		todaysprey = data.todaysprey
	end
	if data and data.completetask then
	   GetPlayer():AddTag("completetask")
	end
	if data and data.accepttask then
	   GetPlayer():AddTag("accepttask")
	end
	if data and data.acceptbigtask then
	   GetPlayer():AddTag("acceptbigtask")
	end
	if data and data.TB_random then
	   TB_random = true
	end
end

inst.OnSave = onsave
inst.OnLoad = onload

return inst
end

return Prefab( "common/task_board", fn, assets, prefabs),
MakePlacer("common/task_board_placer", "task_board", "task_board", "idle") 