require "prefabutil"

local assets =
{
Asset("ANIM", "anim/vending_machine.zip"),
Asset("IMAGE", "images/inventoryimages/vending_machine.tex"),
Asset("ATLAS", "images/inventoryimages/vending_machine.xml"),
}

local prefabs = 
{
"vending_machine",
}

local slotpos_3x3 = {}  --3x3箱子

for y = 2, 0, -1 do
    for x = 0, 2 do
        table.insert(slotpos_3x3, Vector3(80*x-80*2+80, 80*y-80*2+80,0))
    end
end

local function onopen(inst)	
end 

local function onclose(inst) 	
end 

local function itemtest(inst, item, slot)  --可放入的
	--[[
    if item.components.edible then
		if item.components.edible.foodtype == "MEAT" then
		   return true
		end
	end
	if item.prefab == "cave_banana" or item.prefab == "corn" or item.prefab == "pumpkin" or item.prefab == "eggplant" or item.prefab == "durian" or item.prefab == "pomegranate" or item.prefab == "dragonfruit" or item.prefab == "cactus_meat" or item.prefab == "watermelon" or item.prefab == "red_cap" or item.prefab == "green_cap" or item.prefab == "blue_cap" or item.prefab == "houndstooth" or item.prefab == "coins" or item.prefab == "spoiled_food" then
        return true
    end
	return false
	---]]
	return true
end

local function getstatus(inst)
end

local function onhammered(inst, worker)
    inst.components.lootdropper:DropLoot()
	inst.components.container:DropEverything()
    SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
    inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")
    inst:Remove()
end

local function onhit(inst, worker)
inst.AnimState:PlayAnimation("hit")
inst.AnimState:PushAnimation("idle", true)
end

local function onbuilt(inst)
inst.AnimState:PlayAnimation("place")
inst.AnimState:PushAnimation("idle")
end

local function fn(Sim)
local inst = CreateEntity()
local trans = inst.entity:AddTransform()
local anim = inst.entity:AddAnimState()
inst.entity:AddSoundEmitter()

MakeObstaclePhysics(inst, 1)

anim:SetBank("vending_machine")
anim:SetBuild("vending_machine")
--anim:SetMultColour(255/255,105/255,0/255,1)
anim:PlayAnimation("idle")
--trans:SetScale(1, 1, 1)

local minimap = inst.entity:AddMiniMapEntity()
--minimap:SetPriority( 5 )
minimap:SetIcon( "vending_machine.png" )

inst:AddTag("structure")
inst:AddComponent("lootdropper")
inst:AddComponent("workable")
inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
inst.components.workable:SetWorkLeft(4)
inst.components.workable:SetOnFinishCallback(onhammered)
inst.components.workable:SetOnWorkCallback(onhit)

inst:AddComponent("inspectable")
--[[
inst.components.inspectable.getstatus = function()
    local range = 3
    local pos = Vector3(GetPlayer().Transform:GetWorldPosition())
    local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, range)
	for k,v in pairs(ents) do
	if v.prefab == "vending_machine" then
       TheFrontEnd:PushScreen(VEMScreen())
	end
	end
end
--]]
inst:AddComponent("container")
inst.components.container.itemtestfn = itemtest
inst.components.container:SetNumSlots(#slotpos_3x3)
    
inst.components.container.onopenfn = onopen
inst.components.container.onclosefn = onclose

inst.components.container.widgetslotpos = slotpos_3x3
inst.components.container.widgetanimbank = "ui_chest_3x3"
inst.components.container.widgetanimbuild = "ui_chest_3x3"
inst.components.container.widgetpos = Vector3(160,80,0)
inst.components.container.side_align_tip = 160

local widgetbuttoninfo = {
	text = "Coin",
	position = Vector3(-80, -140, 0),
	fn = function(inst)
		local num_found = 0
        for k,v in pairs(inst.components.container.slots) do
            if v and v.prefab ~= "coins" and v.components.stackable then
				if v and v.prefab == "goldnugget" then
			       num_found = num_found + (v.components.stackable:StackSize() * 2)
				   v:Remove()
				--[[elseif v and ( v.prefab == "corn" or v.prefab == "pumpkin" or v.prefab == "eggplant" or v.prefab == "durian" or v.prefab == "pomegranate" or v.prefab == "dragonfruit" or v.prefab == "cactus_meat" or v.prefab == "watermelon" or v.prefab == "red_cap" or v.prefab == "green_cap" or v.prefab == "blue_cap" ) then
				   num_found = num_found + (v.components.stackable:StackSize() * 1)
				   v:Remove()
				elseif v and ( v.prefab == "smallmeat" or v.prefab == "cookedsmallmeat" or v.prefab == "smallmeat_dried" ) then
				   num_found = num_found + (v.components.stackable:StackSize() * 1)
				   v:Remove()
				else
				   num_found = num_found + (v.components.stackable:StackSize() * 0.1)
				   v:Remove()--]]
				end
            end
        end
		if num_found >= 1 then
			for k = 1, num_found do
				local coins = SpawnPrefab("coins")
				inst.components.container:GiveItem(coins)
			end
			GetPlayer().SoundEmitter:PlaySound("dontstarve/HUD/research_available")
		    GetPlayer().components.talker:Say("Look,money.", 5, false)
		else
			GetPlayer().components.talker:Say("Require gold nugget.", 5, false)
		end
end }
local widgetbuttoninfo2 = {
	text = "Shop",
	position = Vector3(80, -140, 0),
	fn = function(inst)
			GetPlayer().components.locomotor:Clear()
		    GetPlayer().components.talker:Say("Okay,let's shop.", 5, false)
			TheFrontEnd:PushScreen(VEMScreen())
end }

inst.components.container.widgetbuttoninfo = widgetbuttoninfo
inst.components.container.widgetbuttoninfo2 = widgetbuttoninfo2

--[[
local function ShouldAcceptItem(inst, item)
    if item.components.edible then
		if item.components.edible.foodtype == "VEGGIE" then
		   return true
		end
		if item.components.edible.foodtype == "MEAT" then
		   return true
		end
	end
	return false
end

local function OnGetItemFromPlayer(inst, giver, item)
    if item.components.edible then 
		local gold = SpawnPrefab("goldnugget")
		if item.components.edible.foodtype == "VEGGIE" then
		   giver.components.inventory:GiveItem(gold)
		end
		if item.components.edible.foodtype == "MEAT" then
		   giver.components.inventory:GiveItem(gold)
		end
	end
end

inst:AddComponent("trader")
inst.components.trader.onaccept = OnGetItemFromPlayer
inst.components.trader:SetAcceptTest(ShouldAcceptItem)
--]]
inst:ListenForEvent( "daytime", function()
    VEM_random = true
end, GetWorld())
--TEST
local function onsave(inst, data)
	if sellItems1 and sellItems2 and sellItems3 and sellItems4 and sellItems5 then
		data.sell1 = {}
		data.sell1 = sellItems1
		data.sell2 = {}
		data.sell2 = sellItems2
		data.sell3 = {}
		data.sell3 = sellItems3
		data.sell4 = {}
		data.sell4 = sellItems4
		data.sell5 = {}
		data.sell5 = sellItems5
		data.VEM_price = {}
		data.VEM_price = PRICE_float
		data.sellrd = VEM_random
	end
end
local function onload(inst, data)
	--GetPlayer():DoTaskInTime(3, function()
	   --GetPlayer().components.talker:Say("LOAD complete.", 5, false)
	--end)
	if data and data.sell1 and data.sell2 and data.sell3 and data.sell4 and data.sell5 then
	   sellItems1 = data.sell1
	   sellItems2 = data.sell2
	   sellItems3 = data.sell3
	   sellItems4 = data.sell4
	   sellItems5 = data.sell5
	end
	if data and (data.sellrd == false) then
	   VEM_random = false
	end
	if data and data.VEM_price then 
	   PRICE_float = data.VEM_price
	end
end

inst.OnSave = onsave
inst.OnLoad = onload
--TEST
return inst
end

return Prefab( "common/vending_machine", fn, assets, prefabs),
MakePlacer("common/vending_machine_placer", "vending_machine", "vending_machine", "idle") 