require "util"
local Screen = require "widgets/screen"
local AnimButton = require "widgets/animbutton"
local Button = require "widgets/button"
local ImageButton = require "widgets/imagebutton"
local TextButton = require "widgets/textbutton"
local Menu = require "widgets/menu"
local Grid = require "widgets/grid"
local Text = require "widgets/text"
local Image = require "widgets/image"
local UIAnim = require "widgets/uianim"
local Spinner = require "widgets/spinner"
local NumericSpinner = require "widgets/numericspinner"
local Widget = require "widgets/widget"
--local Inv = require "widgets/veminventorybar"
local HoverText = require "widgets/vemhoverer"

--require "screens/popupdialog"
local normal_task = 
{
    {"houndstooth", 40, 15},
    {"beefalowool", 40, 15},
	{"boards"     , 20, 15},
	{"stinger"    , 80, 15},
	{"cookedmeat" , 10, 20},
	{"monstermeat", 20, 15},
	{"fish"       , 10, 15},
	{"eel"        ,  5, 30},
	{"honey"      , 20, 15},
	{"dragonfruit", 10, 15},
	{"pomegranate", 10, 15},
	{"pumpkin"    , 10, 15},
}
local difficult_task = 
{
    {"merm"       , 4, 30},
    {"firehound"  , 4, 30},
	{"icehound"   , 4, 30},
	{"walrus"     , 2, 30},
	{"tallbird"   , 3, 30},
	{"knight"     , 4, 25},
	{"bishop"     , 2, 25},
	{"warg"       , 1, 30},
	{"rook"       , 1, 30},
	{"leif"       , 1, 20},
	{"spiderqueen", 1, 30},
}
todaystask = {}
todaysprey = {}

local text_font = UIFONT--NUMBERFONT

TBScreen = Class(Screen, function(self, in_game)
    GetPlayer().components.playercontroller:Enable(false)
	--SetPause(true)
	--Screen._ctor(self, "TBScreen")
	Widget._ctor(self, "TBScreen")
	self.in_game = in_game
    
	self.root = self:AddChild(Widget("ROOT"))
    self.root:SetVAnchor(ANCHOR_MIDDLE)
    self.root:SetHAnchor(ANCHOR_MIDDLE)
    self.root:SetPosition(0,0,0)
    self.root:SetScaleMode(SCALEMODE_PROPORTIONAL)
    
    self.itemspanel = self.root:AddChild( Image( "images/globalpanels_task.xml", "panel_skinny.tex" ) )
	self.itemspanel:SetScale(1,1,1)
	self.itemspanel:SetPosition(-300,0,0)
    --self.inv = self.itemspanel:AddChild(Inv(GetPlayer()))
	--self.inv:SetPosition(-135, 190, 0)
	
	self.task = self.itemspanel:AddChild(Text(DEFAULTFONT, 60))
	self.task:SetString("TASK:\nitems\nmonsters\ngiant")
	self.task:SetScale(.32,.4,.4)
	self.task:SetColour(1,1,1,1)
	self.task:SetPosition(-110, 150, 0)
	
	self.cost = self.itemspanel:AddChild(Text(DEFAULTFONT, 60))
	self.cost:SetString("COST:\nnone\n5meat\n5gems")
	self.cost:SetScale(.32,.4,.4)
	self.cost:SetColour(1,1,1,1)
	self.cost:SetPosition(-20, 150, 0)
	
	self.reward = self.itemspanel:AddChild(Text(DEFAULTFONT, 60))
	self.reward:SetString("REWARD:\ncoins\ncoins&loots\ndemonticket&loots")
	self.reward:SetScale(.32,.4,.4)
	self.reward:SetColour(1,1,1,1)
	self.reward:SetPosition(90, 150, 0)
	
	if TB_random or #todaystask < 3 or #todaysprey < 3 then
		todaystask = normal_task[math.random(#normal_task)]
		todaysprey = difficult_task[math.random(#difficult_task)]
		TB_random = false
	end
	
	local v1 = SpawnPrefab(todaystask[1])
	local str1 = v1:GetDisplayName()
	v1:Remove()
	local v2 = SpawnPrefab(todaysprey[1])
	local str2 = v2:GetDisplayName()
	v2:Remove()
	
	self.showtask = self.itemspanel:AddChild(Text(DEFAULTFONT, 60))
	self.showtask:SetString("---------------------------------------------------------\ntoday's task:\n"..str1.." x"..(todaystask[2]).." ("..(todaystask[3]).." coins)\n"..str2.." x"..(todaysprey[2]).." ("..(todaysprey[3]).." coins)")
	self.showtask:SetScale(.32,.4,.4)
	self.showtask:SetColour(1,1,1,1)
	self.showtask:SetPosition(0, 60, 0)
	
	self.howtouse = self.itemspanel:AddChild(Text(DEFAULTFONT, 60))
	self.howtouse:SetString("-----------------------------\nATTENTION:\nitems-once a day\nmonsters-once a day\ngiant-once a season")
	self.howtouse:SetScale(.32,.4,.4)
	self.howtouse:SetColour(1,1,1,1)
	self.howtouse:SetPosition(-75, -50, 0)
	
	self.closebutton = self.itemspanel:AddChild(ImageButton())
	self.closebutton:SetText(STRINGS.UI.OPTIONS.CLOSE)
    self.closebutton:SetPosition(106, -188, 0)
    self.closebutton:SetScale(0.63)
    self.closebutton:SetOnClick( function() self:Accept() end)
	
	self.hover = self:AddChild(HoverText(self))
	self.hover:SetScaleMode(SCALEMODE_PROPORTIONAL)
	self.hover.isFE = true
end)


function TBScreen:OnControl(control, down)
    if TBScreen._base.OnControl(self, control, down) then return true end
    
    if (control == CONTROL_PAUSE or control == CONTROL_CANCEL) and not down then
		self:Accept()
		return true
    end
end


function TBScreen:Accept()
	GetPlayer().components.playercontroller:Enable(true)
	--SetPause(false)
	--self.inv:Delete()
	TheFrontEnd:PopScreen()
	--PAGE_PRICE = nil
end

function TBScreen:OnUpdate(dt)
	self.hover:Update()
	--self.inv:Update(dt)
end


function TBScreen:UpdateMenu()
	self.menu:Clear()
	self.menu:AddItem(STRINGS.UI.OPTIONS.CLOSE, function() self:Accept() end)
end

