local ItemSlot = require "widgets/itemslot"


local InvSlot = Class(ItemSlot, function(self, num, atlas, bgim, owner, container)
    ItemSlot._ctor(self, atlas, bgim, owner)
    self.owner = owner
    self.container = container
    self.num = num
end)

function InvSlot:GetSlotNum()
    if self.tile and self.tile.item then
        return self.tile.item.components.inventoryitem:GetSlotNum()
    end
end

function InvSlot:OnControl(control, down)
    if InvSlot._base.OnControl(self, control, down) then return true end
    if down then
        
        if control == CONTROL_ACCEPT then
            self:Click(false)
        elseif control == CONTROL_SECONDARY then
            self:Click(true)
        else
            return false
        end
        return true
    end


end


function InvSlot:Click(stack_mod)
    local character = GetPlayer()
    local slot_number = self.num
    local container = self.container
    local container_item = container[slot_number]
	local hasemptyslot = true
	local VEM_inst = nil
	local price = PAGE_PRICE
	
	local range = 3.2
	local pos = Vector3(GetPlayer().Transform:GetWorldPosition())
	local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, range)
	for k,v in pairs(ents) do
		if v.prefab == "vending_machine" then
			VEM_inst = v
		end
	end
	
    if GetPlayer().components.inventory:Has("coins", price) or (VEM_inst and VEM_inst.components.container:Has("coins", price)) then 
	if price >= 80 then 
		if not (GetPlayer().components.inventory:Has("demon_ticket", 1) or (VEM_inst and VEM_inst.components.container:Has("demon_ticket", 1))) then
		    character.SoundEmitter:PlaySound("dontstarve/HUD/click_object")
		    GetPlayer().components.talker:Say("Require demon ticket.", 5, false)
			return InvSlot
		end
	end
    if container_item then
        local loot = SpawnPrefab(container_item.prefab)
		if loot then
			if GetPlayer().components.inventory:IsFull() then
				local equipslot = GetPlayer().components.inventory.equipslots
				local backpack_found = 0
				for k,v in pairs(equipslot) do
					if v and v.prefab == "backpack" or v.prefab == "piggyback"	or v.prefab == "krampus_sack" then
						if not v.components.container:IsFull() then
							backpack_found = backpack_found + 1
						end
					end
				end
				if backpack_found == 0 then
					hasemptyslot = false
				end
			end
			if hasemptyslot then
				character.SoundEmitter:PlaySound("dontstarve/HUD/research_available")
				if VEM_inst and VEM_inst.components.container:Has("coins", price) then
					VEM_inst.components.container:ConsumeByName("coins", price)
				else
					GetPlayer().components.inventory:ConsumeByName("coins", price)
				end
				if price >= 80 then 
					if VEM_inst and VEM_inst.components.container:Has("demon_ticket", 1) then
						VEM_inst.components.container:ConsumeByName("demon_ticket", 1)
					else
						GetPlayer().components.inventory:ConsumeByName("demon_ticket", 1)
					end
				end
				GetPlayer().components.inventory:GiveItem(loot)
			else
				character.SoundEmitter:PlaySound("dontstarve/HUD/click_object")
				GetPlayer().components.talker:Say("I can't take more goods.", 5, false)
			end
		end
        --[[if loot then
        
        	--if stack_mod and loot.components.stackable then
        		--loot.components.stackable.stacksize = 10
        	--end
        
			local pt = Point(character.Transform:GetWorldPosition())
	        
			loot.Transform:SetPosition(pt.x,pt.y,pt.z)
	        
			if loot.Physics then
	        
				local angle = math.random()*2*PI
				loot.Physics:SetVel(2*math.cos(angle), 10, 2*math.sin(angle))

				if loot and loot.Physics and character and character.Physics then
					pt = pt + Vector3(math.cos(angle), 0, math.sin(angle))*((loot.Physics:GetRadius() or 1) + (character.Physics:GetRadius() or 1))
					loot.Transform:SetPosition(pt.x,pt.y,pt.z)
				end
				
				loot:DoTaskInTime(1, 
					function() 
						if not (loot.components.inventoryitem and loot.components.inventoryitem:IsHeld()) then
							if not loot:IsOnValidGround() then
								local fx = SpawnPrefab("splash_ocean")
							    local pos = loot:GetPosition()
    							fx.Transform:SetPosition(pos.x, pos.y, pos.z)
						        --PlayFX(loot:GetPosition(), "splash", "splash_ocean", "idle")
								if loot:HasTag("irreplaceable") then
									loot.Transform:SetPosition(GetPlayer().Transform:GetWorldPosition())
								else
									loot:Remove()
								end
							end
						end
					end)
			end
	        
			return loot
		end
		--]]
	end
	else
	   character.SoundEmitter:PlaySound("dontstarve/HUD/click_object")
	   GetPlayer().components.talker:Say("I need more coins.", 5, false)
	end
end





return InvSlot
